#include <bits/stdc++.h>
 
 using namespace std;
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    
    int n,q;
    cin>>n>>q;
    vector<int>dani(n);
    vector<int>kp(n);
    vector<int>ud(q);
    for(int i=0;i<n;i++){
        cin>>dani[i]>>kp[i];
    }
    for(int i=0;i<q;i++){
        cin>>ud[i];
    
    }
    long long dj=1;
    long long kucip=0;
    long long pp=0;
    long long djbr=0;
    long long j=0;
    while(dj<=ud[q-1]){

        if(dj==dani[j]){
            kucip+=kp[j];
            j++;
            
        }
        if(kucip>=1){
            kucip--;
            pp++;
        }
        if(dj==ud[djbr]){
            cout<<pp<<endl;
            djbr++;
            
        }
        dj++;
    
    
    

    }
    
}